unit iHtml;

interface

uses
    Windows, SysUtils, Classes, WinInet;

type
    //  i̎
    TProgressMode = (pmFirst = 0, pmProgress = 1, pmFinish = 2);
    //  i󋵒ʒmR[obN֐
    TProgress = procedure (const MaxValue, CurValue: integer;
                           const Mode: TProgressMode) of object;
//  HTML\[X擾
function GetHtmlFile(Stream: TStream; const URL: string; Prog: TProgress = nil): Boolean;

implementation

//  ---------------------------------------------------------------------------
//  ȂĂ܂H
function IsOnline(): Boolean;
begin
    Result := InternetAttemptConnect(0) = ERROR_SUCCESS;
end;

//  ---------------------------------------------------------------------------
//  HTML\[X̎擾
function GetHtmlFile(Stream: TStream; const URL: string; Prog: TProgress = nil): Boolean;
const
    UserAgent = 'Mozilla/4.0 (compatible; MSIE 5.5; Windows 98)';
var
    hSess: HINTERNET;
    hServ: HINTERNET;
    Buf: string;
    Len, Sum: Cardinal;
    dwLength: integer;
    dwSize, Dummy: Cardinal;
begin
    Result:=False;

    //  C^[lbgɂȂĂ邩`FbN
    if not IsOnline() then exit;

    //  ZbVJ
    hSess := InternetOpen(PChar(UserAgent), INTERNET_OPEN_TYPE_PRECONFIG, nil, nil, 0);
    try
        //  Ă
        if Assigned(hSess) then
        begin
            //  URLJ
            hServ := InternetOpenUrl(hSess, PChar(url), nil, 0, INTERNET_FLAG_RELOAD, 0);
            try
                //  Ă
                if Assigned(hServ) then
                begin
                    //  t@CTCY擾
                    if HttpSendRequest(hServ, nil, 0, nil, 0) then
                    begin
                        dwSize := SizeOf(dwLength);
                        Dummy := 0;
                        dwLength := 0;
                        HttpQueryInfo(hServ,
                                      HTTP_QUERY_CONTENT_LENGTH + HTTP_QUERY_FLAG_NUMBER,
                                      @dwLength, dwSize, Dummy);
                    end;

                    //  vOXR[
                    if Assigned(Prog) then Prog(dwLength, 0, pmFirst);

                    //  Sǂݍ߂܂łԂ
                    Sum := 0;
                    while true do
                    begin
                        //  ǂݎobt@̃TCY 1024 oCgɃZbg
                        SetLength(Buf, 1024);
                        //  ǂݎ
                        InternetReadFile(hServ, @Buf[1], Length(Buf), Len);
                        //  ǂݍ񂾃TCY𒲂ׂ(0ȂŌ܂ł)
                        Inc(Sum, Len);
                        if Len = 0 then Break;
                        //  vOXR[
                        if Assigned(Prog) then Prog(dwLength, Sum, pmProgress);
                        //  ǂݍ񂾃TCYɃobt@𒲐
                        SetLength(Buf, Len);
                        //  ̃Xg[ɏ
                        Stream.Write(Buf[1], Length(Buf));
                    end;
                    //  vOXR[
                    if Assigned(Prog) then Prog(dwLength, Sum, pmFinish);
                    //  Xg[݈̌ʒuŏɖ߂
                    Stream.Position := 0;
                    Result := True;
                end;
            finally
                //  URL
                InternetCloseHandle(hServ);
            end;
        end;
    finally
        //  ZbV
        InternetCloseHandle(hSess);
    end;
end;

end.

